/***************************************************************************
 *
 *                         INFORMIX SOFTWARE, INC.
 *
 *                            PROPRIETARY DATA
 *
 *      THIS DOCUMENT CONTAINS TRADE SECRET DATA WHICH IS THE PROPERTY OF
 *      INFORMIX SOFTWARE, INC.  THIS DOCUMENT IS SUBMITTED TO RECIPIENT IN
 *      CONFIDENCE.  INFORMATION CONTAINED HEREIN MAY NOT BE USED, COPIED OR
 *      DISCLOSED IN WHOLE OR IN PART EXCEPT AS PERMITTED BY WRITTEN AGREEMENT
 *      SIGNED BY AN OFFICER OF INFORMIX SOFTWARE, INC.
 *
 *      THIS MATERIAL IS ALSO COPYRIGHTED AS AN UNPUBLISHED WORK UNDER
 *      SECTIONS 104 AND 408 OF TITLE 17 OF THE UNITED STATES CODE.
 *      UNAUTHORIZED USE, COPYING OR OTHER REPRODUCTION IS PROHIBITED BY LAW.
 *
 *  Title:      fglsys.h
 *  Description:
 *              Declarations of 4GL internal functions
 *
 *              These declarations are for the benefit of C compilers and
 *              the functions declared are not intended for direct use by
 *              C programmers.
 *
 ***************************************************************************
 */

#ifndef FGLSYS_H
#define FGLSYS_H

#if __STDC__ == 1
#define USE_PROTOTYPES
#endif /* USE_PROTOTYPES */

#include <stdio.h>
#include "datetime.h"
#include "decimal.h"
#include "int8.h"
#include "locator.h"

/* Old function Maping to New Functions */
#define popshort(x)                        ibm_lib4gl_popInt2(x)
#define popint(x)                          ibm_lib4gl_popMInt(x)
#define poplong(x)                         ibm_lib4gl_popInt4(x)
#define popflo(x)                          ibm_lib4gl_popFloat(x)
#define popdub(x)                          ibm_lib4gl_popDouble(x)
#define popdec(x)                          ibm_lib4gl_popDecimal(x)
#define popquote(x, y)                     ibm_lib4gl_popQuotedStr(x, y)
#define popstring(x, y)                    ibm_lib4gl_popString(x, y)
#define popvchar(x, y)                     ibm_lib4gl_popVarChar(x, y)
#define popdate(x)                         ibm_lib4gl_popDate(x)
#define popdtime(x, y)                     ibm_lib4gl_popDateTime(x, y)
#define popinv(x, y)                       ibm_lib4gl_popInterval(x, y)
#define poplocator(x)                      ibm_lib4gl_popBlobLocator(x)

#define retshort(x)                        ibm_lib4gl_returnInt2(x)
#define retint(x)                          ibm_lib4gl_returnMInt(x)
#define retlong(x)                         ibm_lib4gl_returnInt4(x)
#define retflo(x)                          ibm_lib4gl_returnFloat(x)
#define retdub(x)                          ibm_lib4gl_returnDouble(x)
#define retdec(x)                          ibm_lib4gl_returnDecimal(x)
#define retquote(x)                        ibm_lib4gl_returnQuotedStr(x)
#define retstring(x)                       ibm_lib4gl_returnString(x)
#define retvchar(x)                        ibm_lib4gl_returnVarChar(x)
#define retdate(x)                         ibm_lib4gl_returnDate(x)
#define retdtime(x)                        ibm_lib4gl_returnDateTime(x)
#define retinv(x)                          ibm_lib4gl_returnInterval(x)

#ifdef USE_PROTOTYPES

extern void  ibm_lib4gl_popMInt(mint *ip);
extern void  ibm_lib4gl_popInt2(int2 *is);
extern void  ibm_lib4gl_popInt4(int4 *lp);
extern void  ibm_lib4gl_popInt8(ifx_int8_t *bi);
extern void  ibm_lib4gl_popFloat(float *df);
extern void  ibm_lib4gl_popDouble(double *dp);
extern void  ibm_lib4gl_popDecimal(dec_t *dd);
extern void  ibm_lib4gl_popQuotedStr(int1 *str, mint len);
extern void  ibm_lib4gl_popString(int1 *str, mint len);
extern void  ibm_lib4gl_popVarChar(int1 *vc, mint len);
extern void  ibm_lib4gl_popDate(int4 *lp);
extern void  ibm_lib4gl_popDateTime(dtime_t *dtvar, mint qual);
extern void  ibm_lib4gl_popInterval(intrvl_t *invvar, mint qual);
extern void  ibm_lib4gl_popBlobLocator(loc_t **blob);

extern void  ibm_lib4gl_returnMInt(mint i);
extern void  ibm_lib4gl_returnInt2(int2 s);
extern void  ibm_lib4gl_returnInt4(int4 l);
extern void  ibm_lib4gl_returnInt8(ifx_int8_t *bi);
extern void  ibm_lib4gl_returnFloat(float *fp);
extern void  ibm_lib4gl_returnDouble(double *dp);
extern void  ibm_lib4gl_returnDecimal(dec_t *pd);
extern void  ibm_lib4gl_returnQuotedStr(int1 *s);
extern void  ibm_lib4gl_returnString(int1 *s);
extern void  ibm_lib4gl_returnVarChar(int1 *vc);
extern void  ibm_lib4gl_returnDate(int4 l);
extern void  ibm_lib4gl_returnDateTime(dtime_t *dtvar);
extern void  ibm_lib4gl_returnInterval(intrvl_t *invvar);

#else /* USE_PROTOTYPES */

extern void  ibm_lib4gl_popMInt();
extern void  ibm_lib4gl_popInt2();
extern void  ibm_lib4gl_popInt4();
extern void  ibm_lib4gl_popInt8();
extern void  ibm_lib4gl_popFloat();
extern void  ibm_lib4gl_popDouble();
extern void  ibm_lib4gl_popDecimal();
extern void  ibm_lib4gl_popQuotedStr();
extern void  ibm_lib4gl_popString();
extern void  ibm_lib4gl_popVarChar();
extern void  ibm_lib4gl_popDate();
extern void  ibm_lib4gl_popDateTime();
extern void  ibm_lib4gl_popInterval();
extern void  ibm_lib4gl_popBlobLocator();

extern void  ibm_lib4gl_returnMInt();
extern void  ibm_lib4gl_returnInt2();
extern void  ibm_lib4gl_returnInt4();
extern void  ibm_lib4gl_returnInt8();
extern void  ibm_lib4gl_returnFloat();
extern void  ibm_lib4gl_returnDouble();
extern void  ibm_lib4gl_returnDecimal();
extern void  ibm_lib4gl_returnQuotedStr();
extern void  ibm_lib4gl_returnString();
extern void  ibm_lib4gl_returnVarChar();
extern void  ibm_lib4gl_returnDate();
extern void  ibm_lib4gl_returnDateTime();
extern void  ibm_lib4gl_returnInterval();

#endif /* USE_PROTOTYPES */

#endif /* FGLSYS_H */
